POJ 2488(DFS)

A Knight's Journey
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 38555   Accepted: 13076

Description

POJ 2488(DFS)_第1张图片 Background 
The knight is getting bored of seeing the same black and white squares again and again and has decided to make a journey 
around the world. Whenever a knight moves, it is two squares in one direction and one square perpendicular to this. The world of a knight is the chessboard he is living on. Our knight lives on a chessboard that has a smaller area than a regular 8 * 8 board, but it is still rectangular. Can you help this adventurous knight to make travel plans? 

Problem 
Find a path such that the knight visits every square once. The knight can start and end on any square of the board.

Input

The input begins with a positive integer n in the first line. The following lines contain n test cases. Each test case consists of a single line with two positive integers p and q, such that 1 <= p * q <= 26. This represents a p * q chessboard, where p describes how many different square numbers 1, . . . , p exist, q describes how many different square letters exist. These are the first q letters of the Latin alphabet: A, . . .

Output

The output for every scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1. Then print a single line containing the lexicographically first path that visits all squares of the chessboard with knight moves followed by an empty line. The path should be given on a single line by concatenating the names of the visited squares. Each square name consists of a capital letter followed by a number. 
If no such path exist, you should output impossible on a single line.

Sample Input

3
1 1
2 3
4 3

Sample Output

Scenario #1:
A1

Scenario #2:
impossible

Scenario #3:
A1B3C1A2B4C2A3B1C3A4B2C4

Source

TUD Programming Contest 2005, Darmstadt, Germany



题意:有个骑士在点(0,0),问它能否不重复的走完所有的点,如果可以就输出字典序最小的路径,否则就输出impossible



题解:直接暴力DFS就好啦,暴力出所有的路径,按照字典序排序




#include<iostream>
#include<cstdio>
#include<cstring>
#include<vector>
#include<algorithm>
#include<set>
#include<string>
using namespace std;
#define N 30
int t, n, m;
int g[N][N];
bool flag;
int vx[] = { -1,1,-2,2,-1,1,-2,2 };
int vy[] = { 2,2,1,1,-2,-2,-1,-1 };
bool judge(int x, int y)
{
	if (x < 0 || x >= n || y<0 || y >= m)return 0;
	if (g[x][y])return 0;
	return 1;
}
pair<int, int>path[N];
set<string>ans;
void dfs(int x, int y, int stp)
{
	if (stp == n*m)
	{
		string tmp;
		flag = true;
		for (int i = 0; i < stp; i++)
		{
			
			tmp += char(path[i].second + 'A');
			tmp += char(path[i].first + '0'+1);
		}
		ans.insert(tmp);
		return;
	}
	for (int i = 0; i < 8; i++)
	{
		int xx = x + vx[i];
		int yy = y + vy[i];
		if (judge(xx, yy))
		{
			g[xx][yy] = 1;
			path[stp].first = xx;
			path[stp].second = yy;
			dfs(xx, yy, stp + 1);
			g[xx][yy] = 0;
		}
	}
}
int main()
{
#ifdef CDZSC
	freopen("i.txt", "r", stdin);
#endif
	int cas = 0;
	scanf("%d", &t);
	while (t--)
	{
		ans.clear();
		if (cas)puts("");
		printf("Scenario #%d:\n", ++cas);
		flag = false;
		memset(g, 0, sizeof(g));
		scanf("%d%d", &n, &m);
		path[0].first = 0;
		path[0].second = 0;
		g[0][0] = 1;
		dfs(0, 0, 1);
		if (!flag)puts("impossible");
		else
		{
			printf("%s\n", ans.begin()->c_str());
		}
	}
	return 0;
}








你可能感兴趣的:(POJ 2488(DFS))